#ifndef INC_IOS
#define INC_IOS
#include <iostream>
#endif

#include "date.h"

MyDate::MyDate()
{
    m_day = 1;
    m_month = 1;
    m_year = 1;
}

int MyDate::SetDay(int newDay)
// return codes: 0 - ok, 1 - too small, 2 - too big, 3 - february error
{
    if (newDay < 1)
        return 1;
    if (newDay > 31)
        return 2;
    if (newDay >30)
        switch (m_month)
        {
        case 2:
        case 4:
        case 6:
        case 9:
        case 11:
            return 2;
        default:
            ;
        }
    if ((newDay > 29) && (m_month == 2))
        return 3;
    if ( (newDay > 28) && (m_month == 2) && (!IsLeap()) )
        return 3;
    m_day = newDay;
    return 0;
}

int MyDate::SetMonth(int newMonth)
// error codes: 0 - ok, 1 - too small, 2 - too big, 3 - cannot be with current day
{
    if (newMonth < 1)
        return 1;
    if (newMonth > 12)
        return 2;
    if (m_day>30)
        switch (newMonth)
        {
        case 2:
        case 4:
        case 6:
        case 9:
        case 11:
            return 3;
        default:
            ;
        }
    if ((m_day > 29) && (newMonth == 2))
        return 3;
    if ((m_day > 28) && (newMonth == 2) && (!IsLeap()))
        return 3;
    m_month = newMonth;
    return 0;
}

int MyDate::SetYear(int newYear)
{
    if (!newYear)
        return 1;
    int old_year = m_year;
    m_year = newYear;
    if ( (m_day == 29) && (m_month == 2) )
        if (!IsLeap())
        {
            m_year = old_year;
            return 2;
        }
    return 0;
}

MyDate::MyDate(int newDay, int newMonth, int newYear)
{
    m_year = 1;
    m_month = 1;
    m_day = 1;
    if (SetYear(newYear))
        m_year = 1;
    if (SetMonth(newMonth))
        m_month = 1;
    if (SetDay(newDay))
        m_day = 1;
}

int MyDate::GetYear() const
{
    return m_year;
}

int MyDate::GetMonth() const
{
    return m_month;
}

int MyDate::GetDay() const
{
    return m_day;
}

bool MyDate::IsLeap()
{
    if (!(m_year % 400))
        return true;
    if ( (!(m_year % 4)) && (m_year % 100) )
        return true;
    return false;
}

ostream& operator<<(ostream& os, const MyDate& arg)
{
    switch (arg.GetMonth())
    {
    case 1:
        os << "January";
        break;
    case 2:
        os << "February";
        break;
    case 3:
        os << "March";
        break;
    case 4:
        os << "April";
        break;
    case 5:
        os << "May";
        break;
    case 6:
        os << "June";
        break;
    case 7:
        os << "July";
        break;
    case 8:
        os << "August";
        break;
    case 9:
        os << "September";
        break;
    case 10:
        os << "October";
        break;
    case 11:
        os << "November";
        break;
    case 12:
        os << "December";
        break;
    default:
        os << "Unknown fucking month";
    }
    os << " " << arg.GetDay() << ", " << arg.GetYear();
    return os;
}

bool MyDate::KeybInput()
{
    int error, buff;
    do
    {
        cout << "Enter year: ";
        cin >> buff;
        error = SetYear(buff);
        switch (error)
        {
        case 0:
            cout << "OK";
            break;
        case 1:
            cout << "Can't be zero!" << endl;
            //break;
            return true;
        case 2:
            cout << "It's february 29th and year can't be accepted!";
            break;
        }

        cout << endl;
    } while (error);

    do
    {
        cout << "Enter month: ";
        cin >> buff;
        error = SetMonth(buff);
        switch (error)
        {
        case 0:
            cout << "OK";
            break;
        case 1:
            cout << "Too small!";
            break;
        case 2:
            cout << "Too big!";
            break;
        case 3:
            cout << "Cannot be with curent day!";
            break;
        }
        cout << endl;
    } while (error);

    do
    {
        cout << "Enter day: ";
        cin >> buff;
        error = SetDay(buff);
        switch (error)
        {
        case 0:
            cout << "OK";
            break;
        case 1:
            cout << "Too small!";
            break;
        case 2:
            cout << "Too big!";
            break;
        case 3:
            cout << "Re-check leap year!";
            break;
        }
        cout << endl;
    } while (error);
    return false;
}

 void MyDate::Inc()
{
    if ((m_month == 12) && (m_day == 31))
    {
        m_month = 1;
        m_day = 1;
        if (m_year == -1)
            m_year = 1;
        else
            m_year++;
        return;
    }

    if (m_day > 30)
    {
        m_month++;
        m_day = 1;
        return;
    }

    if (m_day > 29)
        switch (m_month)
        {
        case 4:
        case 6:
        case 9:
        case 11:
            m_month++;
            m_day = 1;
            return;
        }

    if ((m_day > 28) && (m_month == 2))
    {
        m_day = 1;
        m_month++;
        return;
    }

    if ((m_day > 27) && (m_month == 2) && (!IsLeap()))
    {
        m_day = 1;
        m_month++;
        return;
    }

    m_day++;
    return;
}
